Freeciv-3.3: /fast/freeciv/nightly/main/common/spaceship.h File Reference

Freeciv-3.3

Loading...
Searching...
No Matches
Data Structures | Macros | Enumerations | Functions | Variables
spaceship.h File Reference
`#include "bitvector.h"`
`#include "support.h"`
`#include "fc_types.h"`

Go to the source code of this file.

## Data Structures

struct | player_spaceship
struct | sship_part_info
struct | spaceship_component

## Macros

#define | NUM_SS_STRUCTURALS 32 /* Used in the network protocol. */
#define | NUM_SS_COMPONENTS 16
#define | NUM_SS_MODULES 12

## Enumerations

enum | spaceship_state { SSHIP_NONE , SSHIP_STARTED , SSHIP_LAUNCHED , SSHIP_ARRIVED }

## Functions

| BV_DEFINE (bv_spaceship_structure, NUM_SS_STRUCTURALS)
void | spaceship_init (struct player_spaceship *ship)
int | num_spaceship_structurals_placed (const struct player_spaceship *ship)
bool | next_spaceship_component (struct player *pplayer, struct player_spaceship *ship, struct spaceship_component *fill)

## Variables

const struct sship_part_info | structurals_info [NUM_SS_STRUCTURALS]
const struct sship_part_info | components_info [NUM_SS_COMPONENTS]
const struct sship_part_info | modules_info [NUM_SS_MODULES]

## Macro Definition Documentation

## ◆ NUM_SS_COMPONENTS

#define NUM_SS_COMPONENTS 16

Definition at line 88 of file spaceship.h.

## ◆ NUM_SS_MODULES

#define NUM_SS_MODULES 12

Definition at line 89 of file spaceship.h.

## ◆ NUM_SS_STRUCTURALS

#define NUM_SS_STRUCTURALS 32 /* Used in the network protocol. */

Definition at line 87 of file spaceship.h.

## Enumeration Type Documentation

## ◆ spaceship_state

enum spaceship_state

Enumerator
SSHIP_NONE |
SSHIP_STARTED |
SSHIP_LAUNCHED |
SSHIP_ARRIVED |

Definition at line 84 of file spaceship.h.

## Function Documentation

## ◆ BV_DEFINE()

BV_DEFINE | ( | bv_spaceship_structure | ,
|  | NUM_SS_STRUCTURALS |
| ) |  |

## ◆ next_spaceship_component()

bool next_spaceship_component | ( | struct player * | pplayer,
|  | struct player_spaceship * | ship,
|  | struct spaceship_component * | fill
| ) |  |

Find (default) place for next spaceship component.

Definition at line 130 of file spaceship.c.

Referenced by adv_spaceship_autoplace(), and spaceship_autoplace().

## ◆ num_spaceship_structurals_placed()

int num_spaceship_structurals_placed | ( | const struct player_spaceship * | ship | ) |

Count the number of structurals placed; that is, in ship->structure[]

Definition at line 113 of file spaceship.c.

Referenced by do_spaceship_place(), and next_spaceship_component().

## ◆ spaceship_init()

void spaceship_init | ( | struct player_spaceship * | ship | ) |

Initialize spaceship struct; can also be used to "cancel" a spaceship (eg, when capital captured).

Definition at line 96 of file spaceship.c.

Referenced by kill_player(), player_defaults(), sg_load_player_main(), sg_load_player_main(), and spaceship_lost().

## Variable Documentation

## ◆ components_info

const struct sship_part_info components_info[NUM_SS_COMPONENTS]

extern

Definition at line 58 of file spaceship.c.

Referenced by next_spaceship_component(), put_spaceship(), and spaceship_calc_derived().

## ◆ modules_info

const struct sship_part_info modules_info[NUM_SS_MODULES]

extern

Definition at line 77 of file spaceship.c.

Referenced by next_spaceship_component(), put_spaceship(), and spaceship_calc_derived().

## ◆ structurals_info

const struct sship_part_info structurals_info[NUM_SS_STRUCTURALS]

extern

Definition at line 23 of file spaceship.c.

Referenced by do_spaceship_place(), next_spaceship_component(), and put_spaceship().